# Overview

This document provides insights into an efficient way handling data. We show not only how to
retrieve data from an publicly accesible webpge but also how the data can be processed afterwards.
We admit that in the examples shown below we definetly drawing from the full, but we consider this
as a proof of concept for how in our modern technological world plain text is still a great way of
processing and documenting data workflow and analyses.

The paper is divided into three main steps, focussing on first preparing, second processing and
last presevering the data and its documentation

![](../img/nfdi-in-emacs-best-practice-overview.png)

# Introduction

## Emacs

## org-mode

> "Org-mode does outlining, note-taking, hyperlinks, spreadsheets, TODO lists, project planning,
> GTD, HTML and LaTeX authoring, all with plain text files in Emacs."
>
> -- Carsten Dominik

In other words...

> "Back to the future for plain text"
>
> -- Carsten Dominik

Let’s make an executive summary of org-mode:

- Module for [Emacs](https://emacs.org)
- Plain text based
- Around since 2003
- Meant for (scientific) text production and organisation
  + project management
  + agenda, diary, journaling
  + personal knowledge management
  + presentation
  + single-source-publishing
  + literate programming
- Extensible and fully customizable

Org-mode is a magnificent tool when it comes to reproducible research [^1], since this combines a
well documented way of analysing a data set.

By combining org-mode with code, we can create a document which not only describes and explains
a process or analysis in the style of literate programming, but also can be automatically run to
generate nicely formatted files run on the most recently available data.

[^1]: Stanisic, Luka, and Arnaud Legrand. 2014. “Effective Reproducible   Research with Org-Mode
and Git.” In /Euro-Par 2014: Parallel Processing Workshops/, edited by Luís Lopes, Julius
Žilinskas, Alexandru Costan, Roberto G. Cascella, Gabor Kecskemeti, Emmanuel Jeannot, Mario
Cannataro, et al., 475–86. Cham: Springer International Publishing.

## org-babel

- What is it and how it relates to org mode

### How to write a Code Cell

Code blocks in org-babel always start and end the same way:

```
#+BEGIN_SRC <language>

#+END_SRC
```

We can also add plenty of metadata before the block:

- `#+NAME` Provides the block with a name, so that we can easily reference it from other code cells

- `#+CAPTION` Provide a caption under the cell when the document is exported

There are also switches we can add after the language that affect how the cell is executed or
processed:

- `:results` Controls how the results of the code execution are handled.

  - `:results output` outputs the results of the cell in the document

  - `:results silent`supresses all output from the cell

  - `:results file` creates a file to contain the output

- `:exports` Controls how the code block itself is treated in the document.

  - `:exports code` includes the code block itself in the document

  - `:exports results` supresses the code, but shows any results generated by the code

  - `:exports both` includes both the code and the results in the document

- `:eval`

 - `:eval yes` The code cell will be evaluated when the document is exported

 - `:eval no` The code cell will not be evaluated when the document is exported. You might use
 this when

 - `:eval no-export` The code will not be evaluated when exporting, but will execute within the
 org-mode buffer

- `:tangle yes` The code in this block will be "tangled" (extracted) into a seperate source file.
This could be useful if you are documenting how to create a script and part of the result of the
document is the final script itself.

There are some additional switches we can add that are specific to the language used in the cell.
For example:

- In Python or R, we can use the `:session <name>` switch to ensure more than one code block share
a session

- In R, we can use `:colnames yes` or `:colnames no` to dictate whether or not column names should
appear in the results. There is a similar switch called `:rownames`

### Variables

We can use `var=<value>` to set a variable that will be available in the code block. This variable
can either be a constant or a reference to another cell's `#+NAME`, in which case the value of the
variable will be set to whatever the result of that cell is.

# Preparing Data

## Wikidata

- What is it
- Who can edit it

## SPARQL

- Related to SQL
- Can be used to query wikidata

## Requesting Our Data

In order to retreive our data from Wikidata...

``` SPARQL
#+NAME: raw-dataset
#+CAPTION: Retrieving the dataset from wikidata
#+HEADER: :url https://query.wikidata.org/sparql
#+HEADER: :format text/csv
#+HEADER: :cache yes :exports both
#+BEGIN_SRC SPARQL -n -k
SELECT ?wLabel ?pLabel
WHERE
{
  ?p wdt:P31 wd:Q98270496 . (ref:consortium)
  ?p wdt:P1416 ?w .         (ref:affiliations)
  SERVICE wikibase:label {
    bd:serviceParam wikibase:language "en" .
  }
}
ORDER BY ASC(?wLabel) ASC(?pLabel)
LIMIT 50
#+END_SRC
```

Our org-babel cell is made up of several components:

- NAME

  * "raw-dataset" is the name of this cell. It will be used later to refer to the output of this
  cell.

- CAPTION
- HEADER
- BEGIN_SRC / END_SRC

## Viewing Our Results

```
| wLabel                                                       | pLabel            |
|--------------------------------------------------------------+-------------------|
| Q105775472                                                   | NFDI4Health       |
| Q1117007                                                     | NFDI4Health       |
| Q115254989                                                   | NFDI4Objects      |
| Q1205424                                                     | NFDI4Objects      |
| Q17575706                                                    | NFDI4Objects      |
| Academy of Sciences and Humanities in Hamburg                | Text+             |
| Academy of Sciences and Literature Mainz                     | NFDI4Culture      |
| Academy of Sciences and Literature Mainz                     | NFDI4Memory       |
| Academy of Sciences and Literature Mainz                     | NFDI4Objects      |
| Academy of Sciences and Literature Mainz                     | Text+             |
| Alfred Wegener Institute for Polar and Marine Research       | NFDI4Biodiversity |
| Alfred Wegener Institute for Polar and Marine Research       | NFDI4DataScience  |
| Alfred Wegener Institute for Polar and Marine Research       | NFDI4Earth        |
| Anthropological Society (Munich)                             | NFDI4Objects      |
| Arachnologische Gesellschaft                                 | NFDI4Biodiversity |
| Arbeitskreis Provenienzforschung e.V.                        | NFDI4Memory       |
| Archivschule Marburg                                         | NFDI4Memory       |
| Archäologische Kommission für Niedersachsen                  | NFDI4Objects      |
| Archäologisches Museum Hamburg und Stadtmuseum Harburg       | NFDI4Objects      |
| Arthistoricum                                                | NFDI4Culture      |
| Association for Data-Intensive Radio Astronomy               | PUNCH4NFDI        |
| Association for Technology and Construction in Agriculture   | FAIRAgro          |
| Association of German Architects                             | NFDI4Culture      |
| Association of Population Based Cancer Registries in Germany | NFDI4Health       |
| Association of states archaeologists                         | NFDI4Objects      |
| BERD@NFDI                                                    | Base4NFDI         |
| Bach-Archiv Leipzig                                          | NFDI4Culture      |
| Bauhaus-Universität Weimar                                   | NFDI4Ing          |
| Bavarian Academy of Sciences and Humanities                  | BERD@NFDI         |
| Bavarian Academy of Sciences and Humanities                  | NFDI4Earth        |
| Bavarian Academy of Sciences and Humanities                  | NFDI4Memory       |
| Bavarian Academy of Sciences and Humanities                  | NFDI4Objects      |
| Bavarian Academy of Sciences and Humanities                  | NFDIxCS           |
| Bavarian Academy of Sciences and Humanities                  | PUNCH4NFDI        |
| Bavarian Academy of Sciences and Humanities                  | Text+             |
| Bavarian Forest National Park                                | NFDI4Biodiversity |
| Bavarian Natural History Collections                         | NFDI4Biodiversity |
| Bavarian Natural History Collections                         | NFDI4Objects      |
| Bavarian State Archaeological Collection                     | NFDI4Objects      |
| Bavarian State Archives                                      | FAIRAgro          |
| Bavarian State Archives                                      | NFDI4Biodiversity |
| Bavarian State Archives                                      | NFDI4Earth        |
| Bavarian State Archives                                      | NFDI4Objects      |
| Bavarian State Library                                       | NFDI4Culture      |
| Bavarian State Library                                       | NFDI4Memory       |
| Bavarian State Research Center for Agriculture               | FAIRAgro          |
| Beethoven House                                              | NFDI4Culture      |
| Beilstein Institute for the Advancement of Chemical Sciences | NFDI4Chem         |
| Berlin State Library                                         | Base4NFDI         |
| Berlin State Library                                         | NFDI4Memory       |

```

# Cleaning Data

You may have noticed that the first few results we got back from wikidata weren't text, but rather
the letter "Q" followed by a series of numbers...

| wLabel     | pLabel       |
| ---------- | ------------ |
| Q105775472 | NFDI4Health  |
| Q1117007   | NFDI4Health  |
| Q115254989 | NFDI4Objects |
| Q1205424   | NFDI4Objects |
| Q17575706  | NFDI4Objects |

## Switching Languages

One of the neat things about org-babel is that we can pass seemlessly pass data between languages.

You may recall from the cell that contained our SPARQ query this bit: `:exports both`. This ensures
that both the code and the results of that cell are present when the file is exported. For our
specific purpose here, that means that other cells can use the output of this cell as input.

We can specifically ask for the results of a previous cell by referencing the name of that cell.
Our SPARQL cell had the line `#+NAME: raw-dataset`, which means we can ask for the result of this
cell by referencing this name as a variable. Let's look at how to do that in the next section.

## Passing Data Between Cells

We'll look at the orb-babel cell first, then at a closer look at the shell command.

```
#+CAPTION: Cleaning the raw data.
#+NAME: clean-dataset
#+BEGIN_SRC sh -n :var input=raw-dataset :colnames yes :exports both
echo "$input" | sed -E '/Q[0-9]+/d'
#+END_SRC
```

## sed and Regex

As a brief explination of the code, we are taking the result of the `raw-dataset` cell, and
assigning that value to the variable "$input". We are then echoing that input, but filtering it
using `sed`, A Unix utility that can be used for parsing and transforming text.

The `-E` switch is telling sed that we are going to use an extended regex expression.

The pattern `'/Q[0-9]+/d'` has a few different components:

- `/` marks the start of the pattern
- `Q[0-9]+` is a regex pattern that says "match lines that contain a ! followed by one or more
digits
- `/d` is a sed command that deletes the current pattern space, which in the context of $input
will be the entire line

## Viewing our Results

```
| wLabel                                                       | pLabel            |
|--------------------------------------------------------------+-------------------|
| Academy of Sciences and Humanities in Hamburg                | Text+             |
| Academy of Sciences and Literature Mainz                     | NFDI4Culture      |
| Academy of Sciences and Literature Mainz                     | NFDI4Memory       |
| Academy of Sciences and Literature Mainz                     | NFDI4Objects      |
| Academy of Sciences and Literature Mainz                     | Text+             |
| Alfred Wegener Institute for Polar and Marine Research       | NFDI4Biodiversity |
| Alfred Wegener Institute for Polar and Marine Research       | NFDI4DataScience  |
| Alfred Wegener Institute for Polar and Marine Research       | NFDI4Earth        |
| Anthropological Society (Munich)                             | NFDI4Objects      |
| Arachnologische Gesellschaft                                 | NFDI4Biodiversity |
| Arbeitskreis Provenienzforschung e.V.                        | NFDI4Memory       |
| Archivschule Marburg                                         | NFDI4Memory       |
| Archäologische Kommission für Niedersachsen                  | NFDI4Objects      |
| Archäologisches Museum Hamburg und Stadtmuseum Harburg       | NFDI4Objects      |
| Arthistoricum                                                | NFDI4Culture      |
| Association for Data-Intensive Radio Astronomy               | PUNCH4NFDI        |
| Association for Technology and Construction in Agriculture   | FAIRAgro          |
| Association of German Architects                             | NFDI4Culture      |
| Association of Population Based Cancer Registries in Germany | NFDI4Health       |
| Association of states archaeologists                         | NFDI4Objects      |
| BERD@NFDI                                                    | Base4NFDI         |
| Bach-Archiv Leipzig                                          | NFDI4Culture      |
| Bauhaus-Universität Weimar                                   | NFDI4Ing          |
| Bavarian Academy of Sciences and Humanities                  | BERD@NFDI         |
| Bavarian Academy of Sciences and Humanities                  | NFDI4Earth        |
| Bavarian Academy of Sciences and Humanities                  | NFDI4Memory       |
| Bavarian Academy of Sciences and Humanities                  | NFDI4Objects      |
| Bavarian Academy of Sciences and Humanities                  | NFDIxCS           |
| Bavarian Academy of Sciences and Humanities                  | PUNCH4NFDI        |
| Bavarian Academy of Sciences and Humanities                  | Text+             |
| Bavarian Forest National Park                                | NFDI4Biodiversity |
| Bavarian Natural History Collections                         | NFDI4Biodiversity |
| Bavarian Natural History Collections                         | NFDI4Objects      |
| Bavarian State Archaeological Collection                     | NFDI4Objects      |
| Bavarian State Archives                                      | FAIRAgro          |
| Bavarian State Archives                                      | NFDI4Biodiversity |
| Bavarian State Archives                                      | NFDI4Earth        |
| Bavarian State Archives                                      | NFDI4Objects      |
| Bavarian State Library                                       | NFDI4Culture      |
| Bavarian State Library                                       | NFDI4Memory       |
| Bavarian State Research Center for Agriculture               | FAIRAgro          |
| Beethoven House                                              | NFDI4Culture      |
| Beilstein Institute for the Advancement of Chemical Sciences | NFDI4Chem         |
| Berlin State Library                                         | Base4NFDI         |
| Berlin State Library                                         | NFDI4Memory       |

```

# Processing Data

# Preserving Data
